#include <graphics.h>
main15()
{
  extern int mx,my,mouse_button,averageflag;
  extern float average[4];
  int i,j,countequal=0;
  char algname[22]="ROUND ROBIN",strnum[6];
  char algnameshort[4][5]={"FCFS","SJF","PBS","RRS"};
  int fillstyle[4]={11,2,10,9},fillcolor[4]={1,5,6,4},res;
  cleardevice();
  hide_ptr();
  border(0,0,getmaxx(),getmaxy());
  msgbox(5,5,635,50,"      C O M P A R A T I V E  A N A L Y S I S  G R A P H",12);
  setcolor(12);
  rectangle(5,100,300,350);
  line(5,140,300,140);
  line(230,100,230,350);
  settextstyle(0,0,1);
  outtextxy(50,115, "ALGORITHMS");
  outtextxy(240,115,"AVERAGE");
  settextstyle(2,0,4);
  setcolor(1); outtextxy(55,165,"FIRST COME FIRST SERVE");
  setcolor(5); outtextxy(55,215,"SHORTEST JOB FIRST");
  setcolor(6); outtextxy(55,265,"PRIORITY  BASED SCHEDULING");
  setcolor(4); outtextxy(55,315,"ROUND ROBIN SCHEDULLING");

  setfillstyle(CLOSE_DOT_FILL,5);
  bar(10,150,40,180);
  setfillstyle(LINE_FILL,2);
  bar(10,200,40,230);
  setfillstyle(WIDE_DOT_FILL,10);
  bar(10,250,40,280);
  setfillstyle(INTERLEAVE_FILL,9);
  bar(10,300,40,330);
  setcolor(11);
  for(i=0;i<4;i++)
  rectangle(10,150+i*50,40,180+i*50);
  setcolor(11);
  for(i=0;i<4;i++)
  {  sprintf(strnum,"%2.2f",average[i]);
     delay(100);
     outtextxy(250,165+i*50,strnum);
  }
  delay(400);
  border(350,100,600,350);
  setcolor(12);
  delay(100);
  settextstyle(0,0,1);
  outtextxy(300,80,"Average Waiting Time ->");
  delay(100);
  settextstyle(0,0,1);
  outtextxy(380,370,"FCFS     SJF     PBS      RRS");
  j=0;
  for(i=1;i<4;i++)
  {
    if (average[i]>average[j]) j=i;
  }
  res=(int)(220.0/average[j]);
  setcolor(11);
  for(i=1;i<4;i++)
  {
    setfillstyle(fillstyle[i],fillcolor[i]);
    for(j=0;j<(int)(average[i]*res);j+=2)
    { bar3d(368+i*58,330-j,408+i*58,330,3,0);
      delay(10);
    }
    bar3d(368+i*58,330-(int)(average[i]*res),408+i*58,330,3,1);
    delay(100);
  }
  j=0;
  for(i=1;i<4;i++)
  {
    if (average[i]==average[j]) countequal++;
    if (average[i]<average[j]) j=i;
  }
  if (countequal==0)
  {
   switch(j)
   {
     case 0:strcpy(algname,"FIRST COME FIRST SERVE");
	    break;
     case 1:strcpy(algname,"SHORTEST JOB FIRST");
	    break;
     case 2:strcpy(algname,"PRIORITY BASED");
	    break;
     }
     settextstyle(0,0,1);
     setcolor(12);
     outtextxy(100,400," The Algorithm with the least average waiting time is ");
     delay(100);
     moveto(200,430);
     outtext(algname);
     delay(75);
     outtext("SCHEDULING");
     }
     else
      {
      settextstyle(0,0,1);
      setcolor(12);
      outtextxy(100,400," The Algorithm with the least average waiting time is ");
      delay(100);
     moveto(250,430);
     outtext(algnameshort[j]);
     for(i=1;i<4;i++)
     { if (average[i]==average[j])
       { delay(75);
	 outtext(" & ");
	 outtext(algnameshort[i]);
       }
     }
     outtext("  SCHEDULING");
   }
   setcolor(4);
   outtextxy(520,450,"Press any key");
   getch();
   flushall();
   wipe();
  }



